/*
 * マウスのキーリピート
 * XButton1::SendWhileButtonPress("{Down}")
 *   (送るキー(Sendコマンドで書くヤツと同じ), 押下解除を待つキー, 最初待ち時間, リピートの待ち時間)
 */
SendWhileButtonPress(Keys, WaitKey="", FirstDelay="0.7", RepeatDeley="0.03") {
	KeyDelayBack:=A_KeyDelay
	WaitKey := (WaitKey=="") ? WaitKey:=A_ThisHotkey : WaitKey
	SetKeyDelay, 0
	Send, %Keys%
	KeyWait, %WaitKey%, T%FirstDelay%
	While (ErrorLevel) {
		Send, %Keys%
		KeyWait, %WaitKey%, T%RepeatDeley%
	}
	SetKeyDelay, %KeyDelayBack%
}
/*
 * ディレイしつつキーリピート
 * XButton1::SendLoopKeyPress("{Down}")
 *   (送るキー(Sendコマンドで書くヤツと同じ), 押下解除を待つキー, 最初待ち時間, リピートの待ち時間)
 */
SendLoopKeyPress(Keys, Limit="10", RepeatDeley="0.03") {
	WinGetActiveTitle, MyWindowTitle
	Loop %Limit% {
		Send, %Keys%
		KeyWait, LButton, D T%RepeatDeley%

		if (!ErrorLevel || !WinActive(MyWindowTitle))
		break
	}
}


/*
 *	「カレマチカノジョ」用マウス拡張スクリプト - 5ボタン用
 *
 *	マウスの中央ボタン ：左クリック連打
 *	マウスの拡張1ボタン：↓キー連打
 *	マウスの拡張2ボタン：↑キー連打
 */

NNKKdelay = %1%	; マウスホイールのリピートの待ち時間
if (!NNKKdelay) {
	NNKKdelay = 0.05	; 既定は0.05秒
}
NNKKpage = %2%	; PageUp/PageDown でマウスホイールを送る回数
if (!NNKKpage) {
	NNKKpage = 10	; 既定は10回
}
NNKKhome = %3%	; Ctrl+PageUp/PageDown でマウスホイールを送る回数
if (!NNKKhome) {
	NNKKhome = 100	; 既定は100回
}
NNKKnum = %4%	; 数字キーでのページ送りの倍数
if (!NNKKnum) {
	NNKKnum = 100	; 既定は100倍
}

#IfWinActive ahk_class TeaTimeGameFrameWork
{
	MButton:: SendWhileButtonPress("{LButton}",   "", 0.5, NNKKdelay)
	XButton1::SendWhileButtonPress("{WheelDown}", "", 0.5, NNKKdelay)
	XButton2::SendWhileButtonPress("{WheelUp}",   "", 0.5, NNKKdelay)

	 Up::  Send, {WheelUp}
	 Down::Send, {WheelDown}

	^Up::  SendLoopKeyPress("{WheelUp}",   NNKKpage, NNKKdelay)
	^Down::SendLoopKeyPress("{WheelDown}", NNKKpage, NNKKdelay)
	 PgUp::SendLoopKeyPress("{WheelUp}",   NNKKpage, NNKKdelay)
	 PgDn::SendLoopKeyPress("{WheelDown}", NNKKpage, NNKKdelay)
	^PgUp::SendLoopKeyPress("{WheelUp}",   NNKKhome, NNKKdelay)
	^PgDn::SendLoopKeyPress("{WheelDown}", NNKKhome, NNKKdelay)

	^1::SendLoopKeyPress("{WheelDown}",  1 * NNKKnum, NNKKdelay)
	^2::SendLoopKeyPress("{WheelDown}",  2 * NNKKnum, NNKKdelay)
	^3::SendLoopKeyPress("{WheelDown}",  3 * NNKKnum, NNKKdelay)
	^4::SendLoopKeyPress("{WheelDown}",  4 * NNKKnum, NNKKdelay)
	^5::SendLoopKeyPress("{WheelDown}",  5 * NNKKnum, NNKKdelay)
	^6::SendLoopKeyPress("{WheelDown}",  6 * NNKKnum, NNKKdelay)
	^7::SendLoopKeyPress("{WheelDown}",  7 * NNKKnum, NNKKdelay)
	^8::SendLoopKeyPress("{WheelDown}",  8 * NNKKnum, NNKKdelay)
	^9::SendLoopKeyPress("{WheelDown}",  9 * NNKKnum, NNKKdelay)
	^0::SendLoopKeyPress("{WheelDown}", 10 * NNKKnum, NNKKdelay)

	^+1::SendLoopKeyPress("{WheelUp}",   1 * NNKKnum, NNKKdelay)
	^+2::SendLoopKeyPress("{WheelUp}",   2 * NNKKnum, NNKKdelay)
	^+3::SendLoopKeyPress("{WheelUp}",   3 * NNKKnum, NNKKdelay)
	^+4::SendLoopKeyPress("{WheelUp}",   4 * NNKKnum, NNKKdelay)
	^+5::SendLoopKeyPress("{WheelUp}",   5 * NNKKnum, NNKKdelay)
	^+6::SendLoopKeyPress("{WheelUp}",   6 * NNKKnum, NNKKdelay)
	^+7::SendLoopKeyPress("{WheelUp}",   7 * NNKKnum, NNKKdelay)
	^+8::SendLoopKeyPress("{WheelUp}",   8 * NNKKnum, NNKKdelay)
	^+9::SendLoopKeyPress("{WheelUp}",   9 * NNKKnum, NNKKdelay)
	^+0::SendLoopKeyPress("{WheelUp}",  10 * NNKKnum, NNKKdelay)
}
#IfWinActive

